package apis

import (
	"fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type MemberRenwalConfig struct {
	api.Api
}

// GetPage 获取会员套餐管理列表
// @Summary 获取会员套餐管理列表
// @Description 获取会员套餐管理列表
// @Tags 会员套餐管理
// @Param packageName query string false "套餐名称"
// @Param status query string false "套餐状态（字典 rewal_status）"
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.MemberRenwalConfig}} "{"code": 200, "data": [...]}"
// @Router /api/v1/member-renwal-config [get]
// @Security Bearer
func (e MemberRenwalConfig) GetPage(c *gin.Context) {
	req := dto.MemberRenwalConfigGetPageReq{}
	s := service.MemberRenwalConfig{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.MemberRenwalConfig, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取会员套餐管理失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取会员套餐管理
// @Summary 获取会员套餐管理
// @Description 获取会员套餐管理
// @Tags 会员套餐管理
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.MemberRenwalConfig} "{"code": 200, "data": [...]}"
// @Router /api/v1/member-renwal-config/{id} [get]
// @Security Bearer
func (e MemberRenwalConfig) Get(c *gin.Context) {
	req := dto.MemberRenwalConfigGetReq{}
	s := service.MemberRenwalConfig{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.MemberRenwalConfig

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取会员套餐管理失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(object, "查询成功")
}

// Insert 创建会员套餐管理
// @Summary 创建会员套餐管理
// @Description 创建会员套餐管理
// @Tags 会员套餐管理
// @Accept application/json
// @Product application/json
// @Param data body dto.MemberRenwalConfigInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/member-renwal-config [post]
// @Security Bearer
func (e MemberRenwalConfig) Insert(c *gin.Context) {
	req := dto.MemberRenwalConfigInsertReq{}
	s := service.MemberRenwalConfig{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	if err := req.Valid(); err != nil {
		e.Error(500, err, "")
		return
	}

	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建会员套餐管理失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改会员套餐管理
// @Summary 修改会员套餐管理
// @Description 修改会员套餐管理
// @Tags 会员套餐管理
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.MemberRenwalConfigUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/member-renwal-config/{id} [put]
// @Security Bearer
func (e MemberRenwalConfig) Update(c *gin.Context) {
	req := dto.MemberRenwalConfigUpdateReq{}
	s := service.MemberRenwalConfig{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	if err := req.Valid(); err != nil {
		e.Error(500, err, "")
		return
	}

	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改会员套餐管理失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "修改成功")
}

// Delete 删除会员套餐管理
// @Summary 删除会员套餐管理
// @Description 删除会员套餐管理
// @Tags 会员套餐管理
// @Param data body dto.MemberRenwalConfigDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/member-renwal-config [delete]
// @Security Bearer
func (e MemberRenwalConfig) Delete(c *gin.Context) {
	s := service.MemberRenwalConfig{}
	req := dto.MemberRenwalConfigDeleteReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除会员套餐管理失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "删除成功")
}
